Bug 206093 - cman doesn't handle short writes (possibly also reads) in socket IO
Summary: cman doesn't handle short writes (possibly also reads) in socket IO
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: cman   
(Show other bugs)
Version: 5.0
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
: ---
Assignee: Christine Caulfield
QA Contact: Cluster QE
URL:
Whiteboard:
Keywords:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2006-09-11 23:21 UTC by Steven Dake
Modified: 2016-04-26 15:28 UTC (History)
1 user (show)

Fixed In Version: RHBA-2007-0575
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2007-11-07 16:58:40 UTC
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)


External Trackers
Tracker ID Priority Status Summary Last Updated
Red Hat Product Errata RHBA-2007:0575 normal SHIPPED_LIVE cman bug fix update 2007-10-31 12:26:24 UTC

Description Steven Dake 2006-09-11 23:21:17 UTC
Description of problem:
in the function send_reply_message, short writes are not handled.  For example,
if a buffer of 64k is written, but only 20k of the message could be sent, res
will equal 20k with the MSG_DONTWAIT flag specified to the send call.

There may be other functions which also don't handle this possible condition in
both read and writes of the sockets in cman.

Version-Release number of selected component (if applicable):
current cvs cman -12

How reproducible:

no test case to test, but the code is wrong via inspection.

If it were to fail, there would be bizarre results which we would not easily be
able to debug in the field.  the aisexec ipc code handles this properly so you
might have a look there for examples.

Steps to Reproduce:
1.
2.
3.
  
Actual results:
short writes not handled

Expected results:
short writes should be handled in a nonblocking way

Additional info:

Comment 1 Christine Caulfield 2006-09-12 13:29:26 UTC
yeah, that's a hangover from when cman messages couldn't be larger than 1500
bytes (less the PIPE_BUF) so it wasn't a problem.

Comment 2 Christine Caulfield 2006-09-14 13:01:28 UTC
Checking in daemon.c;
/cvs/cluster/cluster/cman/daemon/daemon.c,v  <--  daemon.c
new revision: 1.32; previous revision: 1.31
done


Comment 3 Kiersten (Kerri) Anderson 2007-04-23 16:51:43 UTC
Fixing Product Name.  Cluster Suite was merged into Red Hat Enterpise Linux for
5.0.  In addition dlm, fence and ccs were merged into the cman package, so
bugzilla should reflect package name where those utilities are located.

Comment 5 RHEL Product and Program Management 2007-05-01 16:29:15 UTC
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux maintenance release.  Product Management has requested
further review of this request by Red Hat Engineering, for potential
inclusion in a Red Hat Enterprise Linux Update release for currently deployed
products.  This request is not yet committed for inclusion in an Update
release.

Comment 6 RHEL Product and Program Management 2007-05-01 16:29:30 UTC
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux maintenance release.  Product Management has requested
further review of this request by Red Hat Engineering, for potential
inclusion in a Red Hat Enterprise Linux Update release for currently deployed
products.  This request is not yet committed for inclusion in an Update
release.

Comment 9 errata-xmlrpc 2007-11-07 16:58:40 UTC
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHBA-2007-0575.html



Note You need to log in before you can comment on or make changes to this bug.